3 # Copyright (c) 2005, 2006 Junio C Hamano
5 USAGE='[--signoff] [--dotest=<dir>] [--utf8] [--binary] [--3way]
6 [--interactive] [--whitespace=<option>] <mbox>...
7 or, when resuming [--skip | --resolved]'
10 git var GIT_COMMITTER_IDENT >/dev/null || exit
13 echo "$1" >"$dotest/next"
17 stop_here_user_resolve () {
18 if [ -n "$resolvemsg" ]; then
22 cmdline=$(basename $0)
23 if test '' != "$interactive"
27 if test '' != "$threeway"
31 if test '.dotest' != "$dotest"
33 cmdline="$cmdline -d=$dotest"
35 echo "When you have resolved this problem run \"$cmdline --resolved\"."
36 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
42 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
43 "$dotest/patch" "$dotest/info"
44 echo "$next" >"$dotest/next"
50 echo "Cannot fall back to three-way merge."
55 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
57 rm -fr "$dotest"/patch-merge-*
58 mkdir "$dotest/patch-merge-tmp-dir"
60 # First see if the patch records the index info that we can use.
61 git-apply -z --index-info "$dotest/patch" \
62 >"$dotest/patch-merge-index-info" &&
63 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
64 git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
65 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
66 git-write-tree >"$dotest/patch-merge-base+" ||
67 cannot_fallback "Patch does not record usable index information."
69 echo Using index info to reconstruct a base tree...
70 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
71 git-apply $binary --cached <"$dotest/patch"
73 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
74 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
76 cannot_fallback "Did you hand edit your patch?
77 It does not apply to blobs recorded in its index."
80 test -f "$dotest/patch-merge-index" &&
81 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
82 orig_tree=$(cat "$dotest/patch-merge-base") &&
83 rm -fr "$dotest"/patch-merge-* || exit 1
85 echo Falling back to patching base and 3-way merge...
87 # This is not so wrong. Depending on which base we picked,
88 # orig_tree may be wildly different from ours, but his_tree
89 # has the same set of wildly different changes in parts the
90 # patch did not touch, so resolve ends up canceling them,
91 # saying that we reverted all those changes.
93 git-merge-resolve $orig_tree -- HEAD $his_tree || {
94 if test -d "$GIT_DIR/rr-cache"
98 echo Failed to merge in the changes.
105 dotest=.dotest sign= utf8= keep= skip= interactive= resolved= binary= ws= resolvemsg=
107 while case "$#" in 0) break;; esac
110 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
111 dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
112 -d|--d|--do|--dot|--dote|--dotes|--dotest)
113 case "$#" in 1) usage ;; esac; shift
116 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
117 --interacti|--interactiv|--interactive)
118 interactive=t; shift ;;
120 -b|--b|--bi|--bin|--bina|--binar|--binary)
123 -3|--3|--3w|--3wa|--3way)
125 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
127 -u|--u|--ut|--utf|--utf8)
129 -k|--k|--ke|--kee|--keep)
132 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
142 resolvemsg=$(echo "$1" | sed -e "s/^--resolvemsg=//"); shift ;;
145 rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
156 # If the dotest directory exists, but we have finished applying all the
157 # patches in them, clear it out.
158 if test -d "$dotest" &&
159 last=$(cat "$dotest/last") &&
160 next=$(cat "$dotest/next") &&
162 test "$next" -gt "$last"
169 case "$#,$skip$resolved" in
171 # Explicit resume command and we do not have file, so
175 # No file input but without resume parameters; catch
176 # user error to feed us a patch from standard input
177 # when there is already .dotest. This is somewhat
178 # unreliable -- stdin could be /dev/null for example
179 # and the caller did not intend to feed us a patch but
180 # wanted to continue unattended.
187 die "previous dotest directory $dotest still exists but mbox given."
190 # Make sure we are not given --skip nor --resolved
191 test ",$skip,$resolved," = ,,, ||
192 die "Resolve operation not in progress, we are not resuming."
195 mkdir -p "$dotest" || exit
197 git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
202 # -b, -s, -u, -k and --whitespace flags are kept for the
203 # resuming session after a patch failure.
204 # -3 and -i can and must be given when resuming.
205 echo "$binary" >"$dotest/binary"
206 echo " $ws" >"$dotest/whitespace"
207 echo "$sign" >"$dotest/sign"
208 echo "$utf8" >"$dotest/utf8"
209 echo "$keep" >"$dotest/keep"
210 echo 1 >"$dotest/next"
215 files=$(git-diff-index --cached --name-only HEAD) || exit
216 if [ "$files" ]; then
217 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
222 if test "$(cat "$dotest/binary")" = t
224 binary=--allow-binary-replacement
226 if test "$(cat "$dotest/utf8")" = t
230 if test "$(cat "$dotest/keep")" = t
234 ws=`cat "$dotest/whitespace"`
235 if test "$(cat "$dotest/sign")" = t
237 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
239 s/^/Signed-off-by: /'
245 last=`cat "$dotest/last"`
246 this=`cat "$dotest/next"`
249 this=`expr "$this" + 1`
253 if test "$this" -gt "$last"
260 while test "$this" -le "$last"
262 msgnum=`printf "%0${prec}d" $this`
263 next=`expr "$this" + 1`
264 test -f "$dotest/$msgnum" || {
270 # If we are not resuming, parse and extract the patch information
271 # into separate files:
272 # - info records the authorship and title
273 # - msg is the rest of commit log message
274 # - patch is the patch body.
276 # When we are resuming, these files are either already prepared
277 # by the user, or the user can tell us to do so by --resolved flag.
280 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
281 <"$dotest/$msgnum" >"$dotest/info" ||
283 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
287 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
288 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
289 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
291 if test -z "$GIT_AUTHOR_EMAIL"
293 echo "Patch does not have a valid e-mail address."
297 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
299 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
300 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
304 if test '' != "$SIGNOFF"
307 sed -ne '/^Signed-off-by: /p' \
308 "$dotest/msg-clean" |
312 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
313 test '' = "$LAST_SIGNED_OFF_BY" && echo
321 if test -s "$dotest/msg-clean"
324 cat "$dotest/msg-clean"
326 if test '' != "$ADD_SIGNOFF"
330 } >"$dotest/final-commit"
333 case "$resolved$interactive" in
335 # This is used only for interactive view option.
336 git-diff-index -p --cached HEAD >"$dotest/patch"
342 if test "$interactive" = t
345 die "cannot be interactive without stdin connected to a terminal."
347 while test "$action" = again
349 echo "Commit Body is:"
350 echo "--------------------------"
351 cat "$dotest/final-commit"
352 echo "--------------------------"
353 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
357 [aA]*) action=yes interactive= ;;
358 [nN]*) action=skip ;;
359 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
362 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
370 if test $action = skip
376 if test -x "$GIT_DIR"/hooks/applypatch-msg
378 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
383 echo "Applying '$SUBJECT'"
388 git-apply $binary --index $ws "$dotest/patch"
392 # Resolved means the user did all the hard work, and
393 # we do not have to do any patch application. Just
394 # trust what the user has in the index file and the
397 changed="$(git-diff-index --cached --name-only HEAD)"
398 if test '' = "$changed"
400 echo "No changes - did you forget update-index?"
401 stop_here_user_resolve $this
403 unmerged=$(git-ls-files -u)
404 if test -n "$unmerged"
406 echo "You still have unmerged paths in your index"
407 echo "did you forget update-index?"
408 stop_here_user_resolve $this
414 if test $apply_status = 1 && test "$threeway" = t
418 # Applying the patch to an earlier tree and merging the
419 # result may have produced the same tree as ours.
420 changed="$(git-diff-index --cached --name-only HEAD)"
421 if test '' = "$changed"
423 echo No changes -- Patch already applied.
427 # clear apply_status -- we have successfully merged.
431 if test $apply_status != 0
433 echo Patch failed at $msgnum.
434 stop_here_user_resolve $this
437 if test -x "$GIT_DIR"/hooks/pre-applypatch
439 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
442 tree=$(git-write-tree) &&
443 echo Wrote tree $tree &&
444 parent=$(git-rev-parse --verify HEAD) &&
445 commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
446 echo Committed: $commit &&
447 git-update-ref -m "$rloga: $SUBJECT" HEAD $commit $parent ||
450 if test -x "$GIT_DIR"/hooks/post-applypatch
452 "$GIT_DIR"/hooks/post-applypatch